import { JBSelectCallbacks, JBSelectElements, ValidationValue } from "./types";
import { ShowValidationErrorParameters, ValidationHelper, type WithValidation } from "jb-validation";
import { JBFormInputStandards } from 'jb-form';
/**
 *  TValue is the type of value we extract from option
 */
export declare class JBSelectWebComponent<TValue = any> extends HTMLElement implements WithValidation<ValidationValue<TValue>>, JBFormInputStandards<TValue> {
    #private;
    static get formAssociated(): boolean;
    callbacks: JBSelectCallbacks<TValue>;
    elements: JBSelectElements;
    get value(): TValue;
    set value(value: TValue);
    get textValue(): string;
    set textValue(value: string);
    get selectedOptionTitle(): string;
    get placeholder(): string;
    set placeholder(value: string);
    get searchPlaceholder(): string;
    set searchPlaceholder(value: string);
    get isMobileDevice(): boolean;
    get isOpen(): boolean;
    get validation(): ValidationHelper<ValidationValue<TValue>>;
    get disabled(): boolean;
    set disabled(value: boolean);
    set required(value: boolean);
    get required(): boolean;
    /**
   * @description will determine if component trigger jb-validation mechanism automatically on user event or it just let user-developer handle validation mechanism by himself
   */
    get isAutoValidationDisabled(): boolean;
    get name(): string;
    initialValue: TValue | null;
    get isDirty(): boolean;
    constructor();
    connectedCallback(): void;
    static get observedAttributes(): string[];
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    focus(): void;
    blur(): void;
    /**
     * @description show given string as a error in message place
     * @public
     */
    showValidationError(error: ShowValidationErrorParameters | string): void;
    clearValidationError(): void;
    /**
   * @public
   * @description this method used to check for validity but doesn't show error to user and just return the result
   * this method used by #internal of component
   */
    checkValidity(): boolean;
    /**
    * @public
   * @description this method used to check for validity and show error to user
   */
    reportValidity(): boolean;
    get validationMessage(): string;
}
//# sourceMappingURL=jb-select.d.ts.map