import React, { CSSProperties } from 'react';
import 'jb-select';
import { JBSelectWebComponent } from 'jb-select';
import { EventProps } from './events-hook.js';
import { type JBSelectAttributes } from './attributes-hook.js';
export type JBSelectEventType<T> = T & {
    target: JBSelectWebComponent;
};
declare global {
    namespace JSX {
        interface IntrinsicElements {
            'jb-select': JBSelectType;
        }
        interface JBSelectType extends React.DetailedHTMLProps<React.HTMLAttributes<JBSelectWebComponent>, JBSelectWebComponent> {
            class?: string;
            label?: string;
            name?: string;
            required?: string | boolean;
            message?: string;
            tabindex?: string;
        }
    }
}
type TValue = any;
export declare const JBSelect: React.ForwardRefExoticComponent<EventProps & JBSelectAttributes<any> & {
    style?: CSSProperties;
    className?: string;
    children?: React.ReactNode;
} & React.RefAttributes<unknown>>;
export type Props = EventProps & JBSelectAttributes<TValue> & {
    style?: CSSProperties;
    className?: string;
    children?: React.ReactNode;
};
export {};
