import React, { CSSProperties } from 'react';
import 'jb-select';
import { JBSelectWebComponent } from 'jb-select';
import { EventProps } from './events-hook.js';
export type JBSelectEventType<T> = T & {
    target: JBSelectWebComponent;
};
declare global {
    namespace JSX {
        interface IntrinsicElements {
            'jb-select': JBSelectType;
        }
        interface JBSelectType extends React.DetailedHTMLProps<React.HTMLAttributes<JBSelectWebComponent>, JBSelectWebComponent> {
            class?: string;
            label?: string;
            name?: string;
            required?: string | boolean;
            message?: string;
            tabindex?: string;
        }
    }
}
export declare const JBSelect: React.ForwardRefExoticComponent<EventProps & {
    style?: CSSProperties;
    label?: string;
    getSelectedValueDOM?: (option: any) => HTMLElement;
    value?: any;
    required?: boolean;
    message?: string;
    placeholder?: string;
    searchPlaceholder?: string;
    className?: string;
    children?: React.ReactNode;
    name?: string;
} & React.RefAttributes<unknown>>;
export type Props = EventProps & {
    style?: CSSProperties;
    label?: string;
    getSelectedValueDOM?: (option: any) => HTMLElement;
    value?: any;
    required?: boolean;
    message?: string;
    placeholder?: string;
    searchPlaceholder?: string;
    className?: string;
    children?: React.ReactNode;
    name?: string;
};
